import 'package:apex_flutter_plugin/apex_flutter_plugin.dart';
import 'package:apex_flutter_plugin/server.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

void main() {
  debugDefaultTargetPlatformOverride = TargetPlatform.fuchsia;
  runApp(ServerWidget(
    actions: {
      Res: (x) => Res.fromJson(x),
    },
    config: ApiConfig("https://google.com", "1", "1", debugMode: true),
    child: MaterialApp(
      theme: ThemeData(fontFamily: 'IRANSans'),
      home: MyApp(),
    ),
  ));
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: GestureDetector(
          onTap: () {
            ServerWidget.of(context).makeRequest<Res>(Req(), showProgressDialog: true);
          },
          child: Container(
              color: Colors.blue,
              child: Center(child: Text('Hello baby!')))),
    );
  }
}

class Req extends Request {
  Req() : super({"hello": "world!"}, isPrivate: true);
}

class Res extends BaseAction {
  Res(int success, String message) : super(success, message);

  factory Res.fromJson(Map<String, dynamic> json) {
    return Res(json['success'], json['message']);
  }
}
